library Parser;

uses
  Windows, Messages;

var Chrs: Array[0..255] of String;
    f: Integer;
    Buf: Array[0..9] of Char;
    H,H2,CF: Cardinal;
    P,P2: PChar;
    CFF: Array[0..99] of Word;
    CH: Array[0..99] of Cardinal;
    N: Integer;

function mciSendString(lpstrCommand, lpstrReturnString: PAnsiChar; uReturnLength: UINT; hWndCallback: HWND): DWORD; stdcall; external 'winmm.dll' name 'mciSendStringA';

function LowerCase(const S: string): string;
var
  Ch: Char;
  L: Integer;
  Source, Dest: PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do
  begin
    Ch := Source^;
    if (Ch >= 'A') and (Ch <= 'Z') then Inc(Ch, 32);
    Dest^ := Ch;
    Inc(Source);
    Inc(Dest);
    Dec(L);
  end;
end;

function sTextToVK(Str: String): Integer;
begin
Str:=LowerCase(Str);
for f:=0 to 255 do begin
        if Str=Chrs[f] then Break;
end;
if f=256 then f:=-1;
Result:=f;
end;

function CutStr(Str: String; WordNum: Integer): String;
var Pss: Integer;
    NMW: Integer;
begin
pss:=0;
Result:='';
NMW:=0;
While WordNum>0 do begin
        Inc(Pss);
        NMW:=Pss;
        while (Pss<Length(str)) and ((Str[Pss]<>',') or (Str[Pss+1]<>',')) do Inc(Pss);
        Dec(WordNum);
        Inc(Pss);
        if (Pss=Length(str)) and (WordNum>0) then Exit;
        if Pss=Length(str) then break;
end;
Result:=Copy(Str, NMW, Pss-NMW-1);
end;

function ParseScript(Str: PChar): Boolean; stdcall;
var outs: String;
    cn: Integer;
    Key: Integer;
    KeyS, KeyS2: String;
    Txt: Char;
    Flag: Cardinal;
begin
cn:=2;
outs:=CutStr(Str, cn);
if outs<>'' then outs:=CharLower(PChar(outs)) else outs:='';
Result:=True;
while outs<>'' do begin
        if outs='/mn' then SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_MINIMIZE, 0);
        if outs='/mx' then if IsZoomed(GetForegroundWindow) then SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_RESTORE, 0) else SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_MAXIMIZE, 0);
        if outs='/cl' then SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_CLOSE, 0);
        if outs='/tm' then SetWindowPos(GetForegroundWindow, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
        if outs='/ntm' then SetWindowPos(GetForegroundWindow, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
        if outs='/cdo' then mciSendString('Set cdaudio door open', nil, 0, 0);
        if outs='/cdc' then mciSendString('Set cdaudio door closed', nil, 0, 0);
        if outs[1]='+' then begin
                KeyS:=LowerCase(Copy(outs, 2, Length(Outs)-1));
                Key:=sTextToVK(KeyS);
                if Key<$30 then Flag:=KEYEVENTF_EXTENDEDKEY;
                keybd_event(Key, MapVirtualKey(Key, 0), Flag, 0);
        end;
        if outs[1]='-' then begin
                KeyS:=LowerCase(Copy(outs, 2, Length(Outs)-1));
                Key:=sTextToVK(KeyS);
                if Key<$30 then Flag:=KEYEVENTF_EXTENDEDKEY;
                keybd_event(Key, MapVirtualKey(Key, 0), KEYEVENTF_KEYUP or Flag, 0);
        end;
        if outs[1]='*' then begin
                KeyS:=LowerCase(Copy(outs, 2, Length(Outs)-1));
                Key:=sTextToVK(KeyS);
                if Key<$30 then Flag:=KEYEVENTF_EXTENDEDKEY;
                keybd_event(Key, MapVirtualKey(Key, 0), 0, 0);
                keybd_event(Key, MapVirtualKey(Key, 0), KEYEVENTF_KEYUP or Flag, 0);
        end;
        if outs='/txt' then begin
                Inc(cn);
                outs:=CutStr(Str, cn);
                OpenClipboard(0);
                CF:=0;
                N:=0;
                repeat
                        CF:=EnumClipboardFormats(CF);
                        if CF<>0 then begin
                                H:=GetClipboardData(CF);
                                H2:=GlobalAlloc(GMEM_DDESHARE or GMEM_MOVEABLE or GMEM_ZEROINIT, GlobalSize(H));
                                P:=GlobalLock(H);
                                P2:=GlobalLock(H2);
                                CopyMemory(P2, P, GlobalSize(H));
                                GlobalUnlock(H2);
                                GlobalUnlock(H);
                                CFF[N]:=CF;
                                CH[N]:=H2;
                                Inc(N);
                        end;
                until CF=0;
                H2:=GlobalAlloc(GMEM_DDESHARE or GMEM_MOVEABLE or GMEM_ZEROINIT, Length(outs)+1);
                P2:=GlobalLock(H2);
                For F:=1 to Length(outs) do begin
                        P2^:=outs[F];
                        Inc(P2);
                end;
                GlobalUnlock(H2);
                EmptyClipboard;
                SetClipboardData(CF_TEXT, H2);
                CloseClipboard;

//-------------------- We've saved clipboard, so we can print some shit --------------------

                keybd_event($10, MapVirtualKey($10, 0), 0, 0);
                keybd_event($2D, MapVirtualKey($2D, 0), KEYEVENTF_EXTENDEDKEY, 0);
                keybd_event($2D, MapVirtualKey($2D, 0), KEYEVENTF_KEYUP or KEYEVENTF_EXTENDEDKEY, 0);
                keybd_event($10, MapVirtualKey($10, 0), KEYEVENTF_KEYUP, 0);

//-------------------- We've printed clipboard, so now we have to wait 1 seconds and restore clipboard --------------------

                Sleep(1000);
                OpenClipboard(0);
                EmptyClipboard;
                for F:=0 to N-1 do SetClipboardData(CFF[F], CH[F]);
                CloseClipboard;

//-------------------- We've restored clipboard --------------------

        end;
        Inc(cn);
        outs:=CutStr(Str, cn);
        if outs<>'' then outs:=CharLower(PChar(outs)) else outs:='';
end;
end;

exports ParseScript;

begin
// Init key table
for f:=0 to 255 do begin
        GetKeyNameText(MapVirtualKey(f,0) shl 16, @Buf, 256);
        Chrs[f]:=LowerCase(Buf);
end;
Chrs[$03]:='cancel';
Chrs[$0c]:='clear';
Chrs[$13]:='pause';
Chrs[$20]:='space';
Chrs[$21]:='pgup';
Chrs[$22]:='pgdn';
Chrs[$23]:='end';
Chrs[$24]:='home';
Chrs[$25]:='left';
Chrs[$26]:='up';
Chrs[$27]:='right';
Chrs[$28]:='down';
Chrs[$29]:='select';
Chrs[$2d]:='ins';
Chrs[$2e]:='del';
Chrs[$5b]:='lwin';
Chrs[$5c]:='rwin';
Chrs[$5d]:='apps';
end.
